import es, dnd, popuplib, spe, cmdlib, random, gamethread, math, playerlib
from dnd import dnd
from spe import HookAction
from spe import HookType
from getviewplayer import getviewplayer

def load():
    spe.parseINI('dnd/subscripts/signatures/mysigs.ini')
    spe.parseTypesINI('dnd/subscripts/signatures/mytypes.ini')
    spe.detourFunction('Respawn', HookType.Pre, pre_spawn)
    
    cmdlib.registerClientCommand('!missile', missile, '')
    cmdlib.registerClientCommand('!hand', hand, '')
    cmdlib.registerClientCommand('!blink', blink, '')
    cmdlib.registerClientCommand('!acid', acid, '')
    cmdlib.registerClientCommand('!hold', hold, '')
    cmdlib.registerClientCommand('!fireball', fireball, '')
    cmdlib.registerClientCommand('!seeinvis', seeinvis, '')
    cmdlib.registerClientCommand('!fear', fear, '')
    cmdlib.registerClientCommand('!poly', poly, '')
    cmdlib.registerClientCommand('!death', death, '')   
    
    info = popuplib.create('Sorceror Info')
    info.addline('Sorceror Class Information:')
    info.addline('  !spells - Shows spell menu')
    info.addline('  !mana - Shows how much mana you have')
    info.addline('-> 9. Main Menu')
    info.submenu(9, 'main_menu')
    
    spellsg = popuplib.create('Sorceror Spell Menu')
    spellsg.addline('Sorceror Spell Menu')
    spellsg.addline('  !missile - Sends missiles dealing damage- 5 mana')
    spellsg.addline('  !hand - Pushes enemy a bit - 5 mana')
    spellsg.addline('  Level 3: !blink - Escape from combat - 10 mana')
    spellsg.addline('   !acid - DOT damage and melts armor - 15 mana')
    spellsg.addline('  Level 5: !fireball - AOE damage - 20 mana')
    spellsg.addline('    !hold - Holds enemy in place - 20 mana')
    spellsg.addline('  Level 7: !fear - forces enemy to flee - 30 mana')
    spellsg.addline('    !seeinvis - reveals stealthed enemies - 30 mana')   
    spellsg.addline('  Level 9: !poly - changes your or targets appearance')
    spellsg.addline('    into an enemies - 25 mana')
    spellsg.addline('    !death - Your knife attacks can kill - 45 mana')
    
def unload():
    popuplib.delete('Sorceror Info')
    
    spe.undetourFunction('Respawn', HookType.Pre, pre_spawn)
    
    cmdlib.unregisterClientCommand('!missile')
    cmdlib.unregisterClientCommand('!hand')
    cmdlib.unregisterClientCommand('!blink')
    cmdlib.unregisterClientCommand('!acid')
    cmdlib.unregisterClientCommand('!hold')
    cmdlib.unregisterClientCommand('!fireball')
    cmdlib.unregisterClientCommand('!seeinvis')
    cmdlib.unregisterClientCommand('!fear')
    cmdlib.unregisterClientCommand('!poly')
    cmdlib.unregisterClientCommand('!death') 
    
    
def isClass(userid):
    if dnd.Player(userid).getClass() == 'Sorceror':
        return 1
    return 0
                
def distance(user1, user2):
    x,y,z = es.getplayerlocation(user1)
    x1,y1,z1 = es.getplayerlocation(user2)
    return math.sqrt(math.pow((x-x1), 2) + math.pow((y-y1), 2) + math.pow((z-z1), 2))
                
def missile(userid, args):
    if isClass(userid) and dnd.Player(userid).alive():
        if not dnd.Temp(userid).get('mana') >= 5:
            dnd.dndTell(userid, 'You do not have enough mana to use this spell')
        else:
            if dnd.Temp(userid).get('cool down'):
                dnd.dndTell(userid, 'You must wait to cast another spell')
            else:
                enemy = getviewplayer.getplayerview(userid)
                if enemy and es.getplayerteam(enemy) != es.getplayerteam(userid):
                    dnd.Temp(userid).add('mana', -5)
                    dnd.Temp(userid).set('cool down', 1)
                    gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                    dice = min(5, (dnd.Player(userid).getLevel() + 1) / 2)
                    amount = 0
                    while dice:
                        amount += random.randint(1,4) + 1
                        dice -= 1
                    dnd.damage(enemy, userid, amount, 'magic')
                    dnd.dndTell(enemy, 'You were injured for %s health'%(amount))
                    dnd.dndTell(userid, 'You injured %s for %s health'%(es.getplayername(enemy), amount))

def hand(userid, args):
    if isClass(userid) and dnd.Player(userid).alive():
        if not dnd.Temp(userid).get('mana') >= 5:
            dnd.dndTell(userid, 'You do not have enough mana to use this spell')
        else:
            if dnd.Temp(userid).get('cool down'):
                dnd.dndTell(userid, 'You must wait to cast another spell')
            else:
                enemy = getviewplayer.getplayerview(userid)
                if enemy and es.getplayerteam(enemy) != es.getplayerteam(userid):
                    dnd.Temp(userid).add('mana', -5)
                    dnd.Temp(userid).set('cool down', 1)
                    gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                    if not dnd.save(enemy, 'Reflex', 15 + min(dnd.Player(userid).getLevel()/4, 5)):
                        x, y, z = playerlib.getPlayer(userid).get('viewvector')
                        es.setplayerprop(enemy, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s'%(x * 400, y * 400, 400))
                        dnd.dndTell(userid, 'You pushed %s'%es.getplayername(enemy))
                    else:
                        dnd.dndTell(userid, 'They resisted your spell')
    
def blink(userid, args):
    if isClass(userid) and dnd.Player(userid).alive() and dnd.Player(userid).getLevel() > 2:
        if not dnd.Temp(userid).get('mana') >= 10:
            dnd.dndTell(userid, 'You do not have enough mana to use this spell')
        else:
            if dnd.Temp(userid).get('cool down'):
                dnd.dndTell(userid, 'You must wait to cast another spell')
            else:
                dnd.Temp(userid).add('mana', -10)
                dnd.Temp(userid).set('cool down', 1)    
                gamethread.delayedname(3, 'dndtick', dnd.cooldownoff, userid)
                x = random.randint(-100,100) / 100
                y = random.randint(-100,100) / 100
                z = random.randint(1,100) / 100
                es.setplayerprop(userid, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s'%(x * 600, y * 600, z * 600))
                        
def acid(userid, args):
    if isClass(userid) and dnd.Player(userid).alive() and dnd.Player(userid).getLevel() > 2:
        if not dnd.Temp(userid).get('mana') >= 15:
            dnd.dndTell(userid, 'You do not have enough mana to use this spell')
        else:
            if dnd.Temp(userid).get('cool down'):
                dnd.dndTell(userid, 'You must wait to cast another spell')
            else:
                enemy = getviewplayer.getplayerview(userid)
                if enemy and es.getplayerteam(enemy) != es.getplayerteam(userid):
                    dnd.Temp(userid).add('mana', -15)
                    dnd.Temp(userid).set('cool down', 1)
                    gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                    if not dnd.save(enemy, 'Reflex', 15 + min(dnd.Player(userid).getLevel()/4, 5)):
                        dnd.armorregen(enemy, 3, -10)
                        dice = 2
                        rounds = dnd.Player(userid).getLevel() / 3
                        amount = 0
                        while dice:
                            amount += random.randint(1,4)
                            dice -= 1
                        dnd.damage(enemy, userid, amount, 'magic')
                        dnd.dndTell(enemy, 'You were injured for %s health'%(amount))
                        dnd.dndTell(userid, 'You injured %s for %s health'%(es.getplayername(enemy), amount))
                        gamethread.delayedname(3, 'dndtick', aciddamage, (userid, enemy, rounds))
                    else:
                        dnd.dndTell(userid, 'They resisted your spell')
                        
def aciddamage(userid, enemy, rounds=0):
    if dnd.Player(enemy).alive() and int(es.ServerVar('round_ended')) != 1:
        if rounds:
            rounds -= 1
            dice = 2
            amount = 0
            while dice:
                amount += random.randint(1,4)
                dice -= 1
            dnd.damage(enemy, userid, amount, 'magic')
            gamethread.delayedname(3, 'dndtick', aciddamage, (userid, enemy, rounds))
    return 0
                            
def fireball(userid, args):
    if isClass(userid) and dnd.Player(userid).alive() and dnd.Player(userid).getLevel() > 4:
        if not dnd.Temp(userid).get('mana') >= 20:
            dnd.dndTell(userid, 'You do not have enough mana to use this spell')
        else:
            if dnd.Temp(userid).get('cool down'):
                dnd.dndTell(userid, 'You must wait to cast another spell')
            else:
                enemy = getviewplayer.getplayerview(userid)
                if enemy and es.getplayerteam(enemy) != es.getplayerteam(userid):
                    dnd.dndTell(enemy, 'You were hit by a fireball!')
                    dnd.Temp(userid).add('mana', -20)
                    dnd.Temp(userid).set('cool down', 1)
                    gamethread.delayedname(3, 'dndtick', dnd.cooldownoff, userid)
                    dice = min(10, dnd.Player(userid).getLevel())
                    amount = 0
                    while dice:
                        amount += random.randint(1,6)
                        dice -= 1
                    if dnd.save(enemy, 'Reflex', 15 + min(dnd.Player(userid).getLevel()/4, 5)):
                        dnd.damage(enemy, userid, amount/2, 'magic')
                    else:
                        dnd.damage(enemy, userid, amount, 'magic')
                        dnd.burn(enemy, dnd.Player(userid).getLevel()/2)
                    for player in es.getUseridList():
                        if dnd.Player(player).alive() and distance(enemy, player) < 600 and enemy != int(player):
                            dnd.dndTell(player, 'You were hit by a fireball!')
                            dnd.dndTell(userid, 'You hit someone with a fireball!')
                            if dnd.save(player, 'Reflex', 15 + min(dnd.Player(userid).getLevel()/4, 5)):
                                dnd.damage(player, userid, amount/2, 'magic')
                            else:
                                dnd.damage(player, userid, amount, 'magic')
                                dnd.burn(player, dnd.Player(userid).getLevel()/2)


def hold(userid, args):
    if isClass(userid) and dnd.Player(userid).alive() and dnd.Player(userid).getLevel() > 4:
        if not dnd.Temp(userid).get('mana') >= 20:
            dnd.dndTell(userid, 'You do not have enough mana to use this spell')
        else:
            if dnd.Temp(userid).get('cool down'):
                dnd.dndTell(userid, 'You must wait to cast another spell')
            else:
                enemy = getviewplayer.getplayerview(userid)
                if enemy and es.getplayerteam(enemy) != es.getplayerteam(userid):
                    dnd.Temp(userid).add('mana', -20)
                    dnd.Temp(userid).set('cool down', 1)
                    gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                    if not dnd.save(enemy, 'Will', 15 + min(dnd.Player(userid).getLevel()/4, 5)):
                        dnd.freeze(enemy, dnd.Player(userid).getLevel() / 4)
                        dnd.dndTell(userid, 'You have stunned your victim')
                        dnd.dndTell(enemy, 'You were stunned')
                    else:
                        dnd.dndTell(userid, 'They have resisted your spell')
    
def fear(userid, args):
    if isClass(userid) and dnd.Player(userid).alive() and dnd.Player(userid).getLevel() > 6:
        if not dnd.Temp(userid).get('mana') >= 30:
            dnd.dndTell(userid, 'You do not have enough mana to use this spell')
        else:
            if dnd.Temp(userid).get('cool down'):
                dnd.dndTell(userid, 'You must wait to cast another spell')
            else:
                enemy = getviewplayer.getplayerview(userid)
                if enemy and es.getplayerteam(enemy) != es.getplayerteam(userid):
                    dnd.Temp(userid).add('mana', -30)
                    dnd.Temp(userid).set('cool down', 1)
                    gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                    if not dnd.save(enemy, 'Reflex', 15 + min(dnd.Player(userid).getLevel()/4, 5)):
                        '''
                        x = random.randint(-1,1)
                        y = random.randint(-1,1)
                        es.setplayerprop(enemy, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s'%(x * 600, y * 600, 100))
                        gamethread.delayed(.5, es.setplayerprop, (enemy, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s'%(x * 600, y * 600, 100)))
                        gamethread.delayed(1, es.setplayerprop, (enemy, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s'%(x * 600, y * 600, 100)))
                        gamethread.delayed(1.5, es.setplayerprop, (enemy, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s'%(x * 600, y * 600, 100)))
                        '''
                        x, y, z = playerlib.getPlayer(userid).get('viewvector')
                        es.setplayerprop(enemy, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s'%(x * 400, y * 400, 200))
                        gamethread.delayed(.2, es.setplayerprop, (enemy, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s'%(x * 400, y * 400, 200)))
                        gamethread.delayed(.4, es.setplayerprop, (enemy, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s'%(x * 400, y * 400, 200)))
                        gamethread.delayed(.6, es.setplayerprop, (enemy, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s'%(x * 400, y * 400, 100)))
                        dnd.dndTell(enemy, 'You ran in fear!')
                        dnd.dndTell(userid, 'You caused them to run in fear!')
                    else:
                        dnd.dndTell(userid, 'They have resisted your spell')

def seeinvis(userid,args):
    if isClass(userid) and dnd.Player(userid).alive() and dnd.Player(userid).getLevel() > 6:
        if not dnd.Temp(userid).get('mana') >= 30:
            dnd.dndTell(userid, 'You do not have enough mana to use this spell')
        else:
            if dnd.Temp(userid).get('cool down'):
                dnd.dndTell(userid, 'You must wait to cast another spell')
            else:
                dnd.Temp(userid).add('mana', -30)
                dnd.Temp(userid).set('cool down', 1)
                gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                for enemy in es.getUseridList():
                    if es.getplayerteam(enemy) != es.getplayerteam(userid) and dnd.Temp(enemy).get('stealth') < 200:
                        if not dnd.save(enemy, 'Will', 15 + min(dnd.Player(userid).getLevel()/4, 5)):
                            dnd.unstealth(enemy)
                            dnd.dndTell(enemy, 'You were forced out of stealth')
                        else:
                            dnd.dndTell(userid, 'Your spell was resisted')
                
                            
def poly(userid, args):
    if isClass(userid) and dnd.Player(userid).alive() and dnd.Player(userid).getLevel() > 8:
        if not dnd.Temp(userid).get('mana') >= 25:
            dnd.dndTell(userid, 'You do not have enough mana to use this spell')
        else:
            if dnd.Temp(userid).get('cool down'):
                dnd.dndTell(userid, 'You must wait to cast another spell')
            else:
                ally = getviewplayer.getplayerview(userid)
                if es.getplayerteam(ally) == es.getplayerteam(userid):
                    dnd.Temp(userid).add('mana', -25)
                    dnd.Temp(userid).set('cool down', 1)
                    gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                    dnd.disguise(ally, dnd.Player(userid).getLevel() / 1.5)
                    dnd.dndTell(ally, 'You are disguised as an enemy for %s seconds!'%(float(dnd.Player(userid).getLevel()) / 1.5))
                    dnd.dndTell(userid, 'You disguised an ally')

                        
def death(userid, args):
    if isClass(userid) and dnd.Player(userid).alive() and dnd.Player(userid).getLevel() > 8:
        if dnd.Temp(userid).get('cool down'):
            dnd.dndTell(userid, 'You must wait to cast another spell')
        else:
            if not dnd.Temp(userid).get('death knell'):
                if not dnd.Temp(userid).get('mana') >= 45:
                    dnd.dndTell(userid, 'You do not have enough mana to use this spell')
                else:
                    dnd.Temp(userid).add('death knell', 1)
                    dnd.Temp(userid).add('mana', -45)
                    dnd.dndTell(userid, 'Your next knife attack may kill your victim')
            else:
                dnd.dndTell(userid, 'Your knife already has death knell')
    
                                  
def pre_spawn(args):
    userid = es.getuserid(es.gethandlefromindex(spe.getEntityIndex(args[0])))
    if isClass(userid):
        dnd.Temp(userid).add('Fortitude', dnd.Player(userid).getLevel()/2+2)
        dnd.Temp(userid).add('Reflex', dnd.Player(userid).getLevel()/3)
        dnd.Temp(userid).add('Will', dnd.Player(userid).getLevel()/2+2)
        dnd.Temp(userid).set('cool down', 0)
        dnd.Temp(userid).add('mana', dnd.Player(userid).getLevel() * 10)        
    return (HookAction.Continue, 0)
        

            