import es,dnd,popuplib,spe
from dnd import dnd
from spe import HookAction
from spe import HookType

def load():
    spe.parseINI('dnd/subscripts/signatures/mysigs.ini')
    spe.parseTypesINI('dnd/subscripts/signatures/mytypes.ini')
    spe.detourFunction('Respawn', HookType.Pre, pre_spawn)
    Human_Info = popuplib.create('Halfling Info')
    Human_Info.addline('Halfling Race Information:')
    Human_Info.addline(' Speed Penalty')
    Human_Info.addline(' Decently More Stealthed')
    Human_Info.addline(' -5% Decreased Damage')
    Human_Info.addline('-> 9. Main Menu')
    Human_Info.submenu(9, 'main_menu')
    
def unload():
    popuplib.delete('Halfling Info')
    spe.undetourFunction('Respawn', HookType.Pre, pre_spawn)
    
def pre_spawn(args):
    userid = es.getuserid(es.gethandlefromindex(spe.getEntityIndex(args[0])))
    if dnd.Player(userid).getRace() == 'Halfling':
        dnd.Temp(userid).add('health', -10)
    return (HookAction.Continue, 0)
    
def player_spawn(ev):
    userid = ev['userid']
    if dnd.Player(userid).getRace() == 'Halfling':
        if dnd.Temp(userid).get('stealth') < 200:
            dnd.Temp(userid).add('stealth', -50)
        else:
            dnd.speed(userid, -.05)
        dnd.speed(userid, -.2)
        
def player_jump(ev):
    userid = ev['userid']
    if dnd.Player(userid).getRace() == 'Halfling':
        #Apparently there isn't a natural .m_vecBaseVelocity for a player...?
        es.setplayerprop(userid, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s'%(0,0,100))